-- Kranseil
--
-- M@D Author  Headshot XXL   &   Gorli
-- M@D date  29.04.2009
--
-- > Copyright (C) Headshot XXL & Gorli< --
-- > erweitert (C) 2011 Bauer Wolle< --

Kranseil = {}

function Kranseil.prerequisitesPresent(specializations)
	Vehicle.registerJointType("frontloader");
    return SpecializationUtil.hasSpecialization(Steerable, specializations);
end;

function Kranseil:load(xmlFile)
	
    local translationPartNode31 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart31#index"));
    if translationPartNode31 ~= nil then
        self.translationPart31 = {};
        self.translationPart31.node = translationPartNode31;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart31#minTrans"));
        self.translationPart31.minTrans = {};
        self.translationPart31.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart31.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart31.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart31#maxTrans"));
        self.translationPart31.maxTrans = {};
        self.translationPart31.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart31.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart31.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart31.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart31#transTime"), 2)*1000;
        self.translationPart31.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart31#touchTransLimit"), 10);
    end; 
    local translationPartNode32 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart32#index"));
    if translationPartNode32 ~= nil then
        self.translationPart32 = {};
        self.translationPart32.node = translationPartNode32;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart32#minTrans"));
        self.translationPart32.minTrans = {};
        self.translationPart32.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart32.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart32.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart32#maxTrans"));
        self.translationPart32.maxTrans = {};
        self.translationPart32.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart32.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart32.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart32.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart32#transTime"), 2)*1000;
        self.translationPart32.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart32#touchTransLimit"), 10);
    end; 
 
	local translationPartNode33 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart33#index"));
    if translationPartNode33 ~= nil then
        self.translationPart33 = {};
        self.translationPart33.node = translationPartNode33;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart33#minTrans"));
        self.translationPart33.minTrans = {};
        self.translationPart33.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart33.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart33.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart33#maxTrans"));
        self.translationPart33.maxTrans = {};
        self.translationPart33.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart33.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart33.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart33.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart33#transTime"), 2)*1000;
        self.translationPart33.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart33#touchTransLimit"), 10);
    end; 
    local translationPartNode34 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart34#index"));
    if translationPartNode34 ~= nil then
        self.translationPart34 = {};
        self.translationPart34.node = translationPartNode34;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart34#minTrans"));
        self.translationPart34.minTrans = {};
        self.translationPart34.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart34.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart34.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart34#maxTrans"));
        self.translationPart34.maxTrans = {};
        self.translationPart34.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart34.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart34.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart34.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart34#transTime"), 2)*1000;
        self.translationPart34.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart34#touchTransLimit"), 10);
    end; 
    local translationPartNode35 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart35#index"));
    if translationPartNode35 ~= nil then
        self.translationPart35 = {};
        self.translationPart35.node = translationPartNode35;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart35#minTrans"));
        self.translationPart35.minTrans = {};
        self.translationPart35.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart35.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart35.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart35#maxTrans"));
        self.translationPart35.maxTrans = {};
        self.translationPart35.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart35.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart35.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart35.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart35#transTime"), 2)*1000;
        self.translationPart35.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart35#touchTransLimit"), 10);
    end; 
	
    local translationPartNode36 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart36#index"));
    if translationPartNode36 ~= nil then
        self.translationPart36 = {};
        self.translationPart36.node = translationPartNode36;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart36#minTrans"));
        self.translationPart36.minTrans = {};
        self.translationPart36.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart36.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart36.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart36#maxTrans"));
        self.translationPart36.maxTrans = {};
        self.translationPart36.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart36.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart36.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart36.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart36#transTime"), 2)*1000;
        self.translationPart36.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart36#touchTransLimit"), 10);
    end; 
 
    local translationPartNode37 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart37#index"));
    if translationPartNode37 ~= nil then
        self.translationPart37 = {};
        self.translationPart37.node = translationPartNode37;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart37#minTrans"));
        self.translationPart37.minTrans = {};
        self.translationPart37.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart37.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart37.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart37#maxTrans"));
        self.translationPart37.maxTrans = {};
        self.translationPart37.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart37.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart37.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart37.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart37#transTime"), 2)*1000;
        self.translationPart37.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart37#touchTransLimit"), 10);
    end; 
    local translationPartNode38 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart38#index"));
    if translationPartNode38 ~= nil then
        self.translationPart38 = {};
        self.translationPart38.node = translationPartNode38;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart38#minTrans"));
        self.translationPart38.minTrans = {};
        self.translationPart38.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart38.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart38.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart38#maxTrans"));
        self.translationPart38.maxTrans = {};
        self.translationPart38.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart38.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart38.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart38.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart38#transTime"), 2)*1000;
        self.translationPart38.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart38#touchTransLimit"), 10);
    end; 
    local translationPartNode39 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart39#index"));
    if translationPartNode39 ~= nil then
        self.translationPart39 = {};
        self.translationPart39.node = translationPartNode39;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart39#minTrans"));
        self.translationPart39.minTrans = {};
        self.translationPart39.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart39.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart39.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart39#maxTrans"));
        self.translationPart39.maxTrans = {};
        self.translationPart39.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart39.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart39.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart39.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart39#transTime"), 2)*1000;
        self.translationPart39.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart39#touchTransLimit"), 10);
    end; 
        
    local translationPartNode40 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart40#index"));
    if translationPartNode40 ~= nil then
        self.translationPart40 = {};
        self.translationPart40.node = translationPartNode40;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart40#minTrans"));
        self.translationPart40.minTrans = {};
        self.translationPart40.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart40.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart40.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart40#maxTrans"));
        self.translationPart40.maxTrans = {};
        self.translationPart40.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart40.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart40.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart40.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart40#transTime"), 2)*1000;
        self.translationPart40.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart40#touchTransLimit"), 10);
    end; 
    local translationPartNode41 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart41#index"));
    if translationPartNode41 ~= nil then
        self.translationPart41 = {};
        self.translationPart41.node = translationPartNode41;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart41#minTrans"));
        self.translationPart41.minTrans = {};
        self.translationPart41.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart41.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart41.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart41#maxTrans"));
        self.translationPart41.maxTrans = {};
        self.translationPart41.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart41.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart41.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart41.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart41#transTime"), 2)*1000;
        self.translationPart41.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart41#touchTransLimit"), 10);
    end; 
 
    local translationPartNode42 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart42#index"));
    if translationPartNode42 ~= nil then
        self.translationPart42 = {};
        self.translationPart42.node = translationPartNode42;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart42#minTrans"));
        self.translationPart42.minTrans = {};
        self.translationPart42.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart42.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart42.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart42#maxTrans"));
        self.translationPart42.maxTrans = {};
        self.translationPart42.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart42.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart42.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart42.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart42#transTime"), 2)*1000;
        self.translationPart42.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart42#touchTransLimit"), 10);
    end; 
    local translationPartNode43 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart43#index"));
    if translationPartNode43 ~= nil then
        self.translationPart43 = {};
        self.translationPart43.node = translationPartNode43;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart43#minTrans"));
        self.translationPart43.minTrans = {};
        self.translationPart43.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart43.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart43.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart43#maxTrans"));
        self.translationPart43.maxTrans = {};
        self.translationPart43.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart43.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart43.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart43.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart43#transTime"), 2)*1000;
        self.translationPart43.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart43#touchTransLimit"), 10);
    end; 
    local translationPartNode44 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart44#index"));
    if translationPartNode44 ~= nil then
        self.translationPart44 = {};
        self.translationPart44.node = translationPartNode44;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart44#minTrans"));
        self.translationPart44.minTrans = {};
        self.translationPart44.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart44.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart44.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart44#maxTrans"));
        self.translationPart44.maxTrans = {};
        self.translationPart44.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart44.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart44.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart44.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart44#transTime"), 2)*1000;
        self.translationPart44.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart44#touchTransLimit"), 10);
    end; 
    local translationPartNode45 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart45#index"));
    if translationPartNode45 ~= nil then
        self.translationPart45 = {};
        self.translationPart45.node = translationPartNode45;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart45#minTrans"));
        self.translationPart45.minTrans = {};
        self.translationPart45.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart45.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart45.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart45#maxTrans"));
        self.translationPart45.maxTrans = {};
        self.translationPart45.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart45.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart45.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart45.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart45#transTime"), 2)*1000;
        self.translationPart45.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart45#touchTransLimit"), 10);
    end; 
    local translationPartNode46 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart46#index"));
    if translationPartNode46 ~= nil then
        self.translationPart46 = {};
        self.translationPart46.node = translationPartNode46;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart46#minTrans"));
        self.translationPart46.minTrans = {};
        self.translationPart46.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart46.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart46.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart46#maxTrans"));
        self.translationPart46.maxTrans = {};
        self.translationPart46.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart46.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart46.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart46.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart46#transTime"), 2)*1000;
        self.translationPart46.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart46#touchTransLimit"), 10);
    end; 
 
    local translationPartNode47 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart47#index"));
    if translationPartNode47 ~= nil then
        self.translationPart47 = {};
        self.translationPart47.node = translationPartNode47;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart47#minTrans"));
        self.translationPart47.minTrans = {};
        self.translationPart47.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart47.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart47.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart47#maxTrans"));
        self.translationPart47.maxTrans = {};
        self.translationPart47.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart47.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart47.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart47.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart47#transTime"), 2)*1000;
        self.translationPart47.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart47#touchTransLimit"), 10);
    end; 
    local translationPartNode48 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart48#index"));
    if translationPartNode48 ~= nil then
        self.translationPart48 = {};
        self.translationPart48.node = translationPartNode48;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart48#minTrans"));
        self.translationPart48.minTrans = {};
        self.translationPart48.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart48.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart48.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart48#maxTrans"));
        self.translationPart48.maxTrans = {};
        self.translationPart48.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart48.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart48.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart48.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart48#transTime"), 2)*1000;
        self.translationPart48.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart48#touchTransLimit"), 10);
    end; 
    local translationPartNode49 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart49#index"));
    if translationPartNode49 ~= nil then
        self.translationPart49 = {};
        self.translationPart49.node = translationPartNode49;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart49#minTrans"));
        self.translationPart49.minTrans = {};
        self.translationPart49.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart49.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart49.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart49#maxTrans"));
        self.translationPart49.maxTrans = {};
        self.translationPart49.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart49.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart49.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart49.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart49#transTime"), 2)*1000;
        self.translationPart49.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart49#touchTransLimit"), 10);
    end; 
        
    local translationPartNode50 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart50#index"));
    if translationPartNode50 ~= nil then
        self.translationPart50 = {};
        self.translationPart50.node = translationPartNode50;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart50#minTrans"));
        self.translationPart50.minTrans = {};
        self.translationPart50.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart50.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart50.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart50#maxTrans"));
        self.translationPart50.maxTrans = {};
        self.translationPart50.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart50.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart50.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart50.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart50#transTime"), 2)*1000;
        self.translationPart50.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart50#touchTransLimit"), 10);
    end; 
    local translationPartNode51 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart51#index"));
    if translationPartNode51 ~= nil then
        self.translationPart51 = {};
        self.translationPart51.node = translationPartNode51;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart51#minTrans"));
        self.translationPart51.minTrans = {};
        self.translationPart51.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart51.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart51.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart51#maxTrans"));
        self.translationPart51.maxTrans = {};
        self.translationPart51.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart51.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart51.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart51.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart51#transTime"), 2)*1000;
        self.translationPart21.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart51#touchTransLimit"), 10);
    end; 
 
    local translationPartNode52 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart52#index"));
    if translationPartNode52 ~= nil then
        self.translationPart52 = {};
        self.translationPart52.node = translationPartNode52;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart52#minTrans"));
        self.translationPart52.minTrans = {};
        self.translationPart52.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart52.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart52.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart52#maxTrans"));
        self.translationPart52.maxTrans = {};
        self.translationPart52.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart52.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart52.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart52.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart52#transTime"), 2)*1000;
        self.translationPart52.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart52#touchTransLimit"), 10);
    end; 
    local translationPartNode53 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart53#index"));
    if translationPartNode53 ~= nil then
        self.translationPart53 = {};
        self.translationPart53.node = translationPartNode53;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart53#minTrans"));
        self.translationPart53.minTrans = {};
        self.translationPart53.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart53.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart53.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart53#maxTrans"));
        self.translationPart53.maxTrans = {};
        self.translationPart53.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart53.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart53.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart53.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart53#transTime"), 2)*1000;
        self.translationPart53.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart53#touchTransLimit"), 10);
    end; 
    local translationPartNode54 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart54#index"));
    if translationPartNode54 ~= nil then
        self.translationPart54 = {};
        self.translationPart54.node = translationPartNode54;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart54#minTrans"));
        self.translationPart54.minTrans = {};
        self.translationPart54.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart54.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart54.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart54#maxTrans"));
        self.translationPart54.maxTrans = {};
        self.translationPart54.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart54.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart54.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart54.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart54#transTime"), 2)*1000;
        self.translationPart54.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart54#touchTransLimit"), 10);
    end; 
    local translationPartNode55 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart55#index"));
    if translationPartNode55 ~= nil then
        self.translationPart55 = {};
        self.translationPart55.node = translationPartNode55;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart55#minTrans"));
        self.translationPart55.minTrans = {};
        self.translationPart55.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart55.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart55.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart55#maxTrans"));
        self.translationPart55.maxTrans = {};
        self.translationPart55.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart55.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart55.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart55.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart55#transTime"), 2)*1000;
        self.translationPart55.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart55#touchTransLimit"), 10);
    end; 
local translationPartNode56 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPart56#index"));
    if translationPartNode56 ~= nil then
        self.translationPart56 = {};
        self.translationPart56.node = translationPartNode56;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart56#minTrans"));
        self.translationPart56.minTrans = {};
        self.translationPart56.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart56.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart56.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPart56#maxTrans"));
        self.translationPart56.maxTrans = {};
        self.translationPart56.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPart56.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPart56.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPart56.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart56#transTime"), 2)*1000;
        self.translationPart56.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPart56#touchTransLimit"), 10);
    end; 
   
    local rotationNode11 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation11#index"));
    if rotationNode11 ~= nil then
        self.rotation11 = {};
        self.rotation11.node = rotationNode11;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#minRot"));
        self.rotation11.minRot = {};
        self.rotation11.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation11#maxRot"));
        self.rotation11.maxRot = {};
        self.rotation11.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation11.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation11.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation11.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#rotTime"), 2)*1000;
        self.rotation11.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation11#touchRotLimit"), 10));
    end;
	
    local rotationNode12 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation12#index"));
    if rotationNode12 ~= nil then
        self.rotation12 = {};
        self.rotation12.node = rotationNode12;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#minRot"));
        self.rotation12.minRot = {};
        self.rotation12.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation12#maxRot"));
        self.rotation12.maxRot = {};
        self.rotation12.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation12.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation12.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation12.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#rotTime"), 2)*1000;
        self.rotation12.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation12#touchRotLimit"), 10));
    end;
    local rotationNode13 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation13#index"));
    if rotationNode13 ~= nil then
        self.rotation13 = {};
        self.rotation13.node = rotationNode13;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#minRot"));
        self.rotation13.minRot = {};
        self.rotation13.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation13#maxRot"));
        self.rotation13.maxRot = {};
        self.rotation13.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation13.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation13.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation13.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#rotTime"), 2)*1000;
        self.rotation13.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation13#touchRotLimit"), 10));
    end;
    local rotationNode14 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotation14#index"));
    if rotationNode14 ~= nil then
        self.rotation14 = {};
        self.rotation14.node = rotationNode14;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#minRot"));
        self.rotation14.minRot = {};
        self.rotation14.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotation14#maxRot"));
        self.rotation14.maxRot = {};
        self.rotation14.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotation14.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotation14.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotation14.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#rotTime"), 2)*1000;
        self.rotation14.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotation14#touchRotLimit"), 10));
    end;
end;
      
function Kranseil:delete()
end;

function Kranseil:mouseEvent(posX, posY, isDown, isUp, button)
end;
	  
function Kranseil:keyEvent(unicode, sym, modifier, isDown)
if sym == Input.KEY_t then
		self.translationMax31 = isDown;
		self.translationMax32 = isDown;
                self.translationMax33 = isDown;
		self.translationMax34 = isDown;
                self.translationMax35 = isDown;
                self.translationMax36 = isDown;
		self.translationMax37 = isDown; 
                self.translationMax38 = isDown;
                self.translationMax39 = isDown;
		self.translationMax40 = isDown; 
		self.translationMax56 = isDown;
               
	end;               

	if sym == Input.KEY_g then
		self.translationMin31 = isDown;
		self.translationMin32 = isDown;
                self.translationMin33 = isDown;
		self.translationMin34 = isDown;
                self.translationMin35 = isDown;               
		self.translationMin36 = isDown;
		self.translationMin37 = isDown;
                self.translationMin38 = isDown;
                self.translationMin39 = isDown;
		self.translationMin40 = isDown;
		self.translationMin56 = isDown;
               
	end;  
 if sym == Input.KEY_v then
		self.translationMax45 = isDown;		
	end;
	if sym == Input.KEY_b then
		self.translationMin45 = isDown;
		
	end;    
       
       
        

	if sym == Input.KEY_o then
		self.rotation11Max = isDown;
	end;
	if sym == Input.KEY_u then
		self.rotation11Min = isDown;
	end;
	if sym == Input.KEY_y then
		self.rotation12Max = isDown;
	end;
	if sym == Input.KEY_x then
		self.rotation12Min = isDown;
	end;
	if sym == Input.KEY_KP_ then
		self.rotation13Max = isDown;
	end;
	if sym == Input.KEY_KP_ then
		self.rotation13Min = isDown;
		end;
	if sym == Input.KEY_ then
		self.rotation14Max = isDown;
	end;
	if sym == Input.KEY_ then
		self.rotation14Min = isDown;
	end;
        
       

end;      
  


function Kranseil:update(dt)
	
	local doTranslate = self.translationMax31 or self.translationMin31 
	if self.translationPart31 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart31.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart31.maxTrans, self.translationPart31.minTrans, 3, self.translationPart31.transTime, dt, not self.translationMax31); 
		setTranslation(self.translationPart31.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax32 or self.translationMin32 
	if self.translationPart32 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart32.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart32.maxTrans, self.translationPart32.minTrans, 3, self.translationPart32.transTime, dt, not self.translationMax32); 
		setTranslation(self.translationPart32.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax33 or self.translationMin33 
	if self.translationPart33 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart33.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart33.maxTrans, self.translationPart33.minTrans, 3, self.translationPart33.transTime, dt, not self.translationMax33); 
		setTranslation(self.translationPart33.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax34 or self.translationMin34 
	if self.translationPart34 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart34.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart34.maxTrans, self.translationPart34.minTrans, 3, self.translationPart34.transTime, dt, not self.translationMax34); 
		setTranslation(self.translationPart34.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax35 or self.translationMin35 
	if self.translationPart35 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart35.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart35.maxTrans, self.translationPart35.minTrans, 3, self.translationPart35.transTime, dt, not self.translationMax35); 
		setTranslation(self.translationPart35.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax36 or self.translationMin36 
	if self.translationPart36 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart36.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart36.maxTrans, self.translationPart36.minTrans, 3, self.translationPart36.transTime, dt, not self.translationMax36); 
		setTranslation(self.translationPart36.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax37 or self.translationMin37 
	if self.translationPart37 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart37.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart37.maxTrans, self.translationPart37.minTrans, 3, self.translationPart37.transTime, dt, not self.translationMax37); 
		setTranslation(self.translationPart37.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax38 or self.translationMin38 
	if self.translationPart38 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart38.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart38.maxTrans, self.translationPart38.minTrans, 3, self.translationPart38.transTime, dt, not self.translationMax38); 
		setTranslation(self.translationPart38.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax39 or self.translationMin39 
	if self.translationPart39 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart39.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart39.maxTrans, self.translationPart39.minTrans, 3, self.translationPart39.transTime, dt, not self.translationMax39); 
		setTranslation(self.translationPart39.node, unpack(newTrans)); 
	end;
             
        local doTranslate = self.translationMax40 or self.translationMin40 
	if self.translationPart40 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart40.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart40.maxTrans, self.translationPart40.minTrans, 3, self.translationPart40.transTime, dt, not self.translationMax40); 
		setTranslation(self.translationPart40.node, unpack(newTrans)); 
	end; 
        local doTranslate = self.translationMax41 or self.translationMin41 
	if self.translationPart41 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart41.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart41.maxTrans, self.translationPart41.minTrans, 3, self.translationPart41.transTime, dt, not self.translationMax41); 
		setTranslation(self.translationPart41.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax42 or self.translationMin42 
	if self.translationPart42 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart42.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart42.maxTrans, self.translationPart42.minTrans, 3, self.translationPart42.transTime, dt, not self.translationMax42); 
		setTranslation(self.translationPart42.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax43 or self.translationMin43 
	if self.translationPart43 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart43.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart43.maxTrans, self.translationPart43.minTrans, 3, self.translationPart43.transTime, dt, not self.translationMax43); 
		setTranslation(self.translationPart43.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax44 or self.translationMin44 
	if self.translationPart44 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart44.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart44.maxTrans, self.translationPart44.minTrans, 3, self.translationPart44.transTime, dt, not self.translationMax44); 
		setTranslation(self.translationPart44.node, unpack(newTrans)); 
	end;  
        local doTranslate = self.translationMax45 or self.translationMin45 
	if self.translationPart45 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart45.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart45.maxTrans, self.translationPart45.minTrans, 3, self.translationPart45.transTime, dt, not self.translationMax45); 
		setTranslation(self.translationPart45.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax46 or self.translationMin46 
	if self.translationPart46 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart46.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart46.maxTrans, self.translationPart46.minTrans, 3, self.translationPart46.transTime, dt, not self.translationMax46); 
		setTranslation(self.translationPart46.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax47 or self.translationMin47 
	if self.translationPart47 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart47.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart47.maxTrans, self.translationPart47.minTrans, 3, self.translationPart47.transTime, dt, not self.translationMax47); 
		setTranslation(self.translationPart47.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax48 or self.translationMin48 
	if self.translationPart48 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart48.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart48.maxTrans, self.translationPart48.minTrans, 3, self.translationPart48.transTime, dt, not self.translationMax48); 
		setTranslation(self.translationPart48.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax49 or self.translationMin49 
	if self.translationPart49 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart49.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart49.maxTrans, self.translationPart49.minTrans, 3, self.translationPart49.transTime, dt, not self.translationMax49); 
		setTranslation(self.translationPart49.node, unpack(newTrans)); 
	end;             
        local doTranslate = self.translationMax50 or self.translationMin50 
	if self.translationPart50 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart50.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart50.maxTrans, self.translationPart50.minTrans, 3, self.translationPart50.transTime, dt, not self.translationMax50); 
		setTranslation(self.translationPart50.node, unpack(newTrans)); 
	end; 
        local doTranslate = self.translationMax51 or self.translationMin51 
	if self.translationPart51 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart51.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart51.maxTrans, self.translationPart51.minTrans, 3, self.translationPart51.transTime, dt, not self.translationMax51); 
		setTranslation(self.translationPart51.node, unpack(newTrans)); 
	end;
	local doTranslate = self.translationMax52 or self.translationMin52 
	if self.translationPart52 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart52.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart52.maxTrans, self.translationPart52.minTrans, 3, self.translationPart52.transTime, dt, not self.translationMax52); 
		setTranslation(self.translationPart52.node, unpack(newTrans)); 
	end;
        local doTranslate = self.translationMax53 or self.translationMin53 
	if self.translationPart53 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart53.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart53.maxTrans, self.translationPart53.minTrans, 3, self.translationPart53.transTime, dt, not self.translationMax53); 
		setTranslation(self.translationPart53.node, unpack(newTrans)); 
	end; 
	local doTranslate = self.translationMax54 or self.translationMin54 
	if self.translationPart54 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart54.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart54.maxTrans, self.translationPart54.minTrans, 3, self.translationPart54.transTime, dt, not self.translationMax54); 
		setTranslation(self.translationPart54.node, unpack(newTrans)); 
	end;  
        local doTranslate = self.translationMax55 or self.translationMin55 
	if self.translationPart55 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart55.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart55.maxTrans, self.translationPart55.minTrans, 3, self.translationPart55.transTime, dt, not self.translationMax55); 
		setTranslation(self.translationPart55.node, unpack(newTrans)); 
	end; 
local doTranslate = self.translationMax56 or self.translationMin56 
	if self.translationPart56 ~= nil and doTranslate then 
		local x, y, z = getTranslation(self.translationPart56.node); 
		local trans = {x,y,z}; 
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPart56.maxTrans, self.translationPart56.minTrans, 3, self.translationPart56.transTime, dt, not self.translationMax56); 
		setTranslation(self.translationPart56.node, unpack(newTrans)); 
	end; 

        
	local doRotate = self.rotation11Max or self.rotation11Min 
	if self.rotation11 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation11.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation11.maxRot, self.rotation11.minRot, 3, self.rotation11.rotTime, dt, not self.rotation11Max);
        setRotation(self.rotation11.node, unpack(newRot));
    end;
	
	local doRotate = self.rotation12Max or self.rotation12Min 
	if self.rotation12 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation12.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation12.maxRot, self.rotation12.minRot, 3, self.rotation12.rotTime, dt, not self.rotation12Max);
        setRotation(self.rotation12.node, unpack(newRot));
    end;
        local doRotate = self.rotation13Max or self.rotation13Min 
	if self.rotation13 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation13.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation13.maxRot, self.rotation13.minRot, 3, self.rotation13.rotTime, dt, not self.rotation13Max);
        setRotation(self.rotation13.node, unpack(newRot));
    end;
        local doRotate = self.rotation14Max or self.rotation14Min
	if self.rotation14 ~= nil and doRotate then
        local x, y, z = getRotation(self.rotation14.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotation14.maxRot, self.rotation14.minRot, 3, self.rotation14.rotTime, dt, not self.rotation14Max);
        setRotation(self.rotation14.node, unpack(newRot));
    end;
end;

function Kranseil:draw()
end;

function Kranseil:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;
